/*!
 * vue-transcript-editor v0.4.0 
 * (c) 2021 Konstantint Travin
 * Released under the MIT License.
 */
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue-plyr'), require('moment')) :
  typeof define === 'function' && define.amd ? define(['exports', 'vue-plyr', 'moment'], factory) :
  (global = global || self, factory(global.VueTranscriptEditor = {}, global.VuePlyr, global.moment));
}(this, (function (exports, VuePlyr, moment) { 'use strict';

  VuePlyr = VuePlyr && Object.prototype.hasOwnProperty.call(VuePlyr, 'default') ? VuePlyr['default'] : VuePlyr;
  moment = moment && Object.prototype.hasOwnProperty.call(moment, 'default') ? moment['default'] : moment;

  //
  //
  //
  //
  //
  //
  //
  //
  var script = {
    name: "EmotionSwitcher",
    props: {
      isHide: {
        required: true,
        type: Boolean
      }
    },
    data: function data() {
      return {
        switcherIsHide: this.isHide
      };
    },
    computed: {
      condition: function condition() {
        return {
          show: "Включить эмоции",
          hide: "Скрыть эмоции"
        };
      },
      content: function content() {
        return this.switcherIsHide ? this.condition.show : this.condition.hide;
      }
    },
    methods: {
      toggle: function toggle() {
        this.switcherIsHide = !this.switcherIsHide;
        this.$emit("emotionToggle");
      }
    }
  };

  function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier
  /* server only */
  , shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
      createInjectorSSR = createInjector;
      createInjector = shadowMode;
      shadowMode = false;
    } // Vue.extend constructor export interop.


    var options = typeof script === 'function' ? script.options : script; // render functions

    if (template && template.render) {
      options.render = template.render;
      options.staticRenderFns = template.staticRenderFns;
      options._compiled = true; // functional template

      if (isFunctionalTemplate) {
        options.functional = true;
      }
    } // scopedId


    if (scopeId) {
      options._scopeId = scopeId;
    }

    var hook;

    if (moduleIdentifier) {
      // server build
      hook = function hook(context) {
        // 2.3 injection
        context = context || // cached call
        this.$vnode && this.$vnode.ssrContext || // stateful
        this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext; // functional
        // 2.2 with runInNewContext: true

        if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
          context = __VUE_SSR_CONTEXT__;
        } // inject component styles


        if (style) {
          style.call(this, createInjectorSSR(context));
        } // register component module identifier for async chunk inference


        if (context && context._registeredComponents) {
          context._registeredComponents.add(moduleIdentifier);
        }
      }; // used by ssr in case component is cached and beforeCreate
      // never gets called


      options._ssrRegister = hook;
    } else if (style) {
      hook = shadowMode ? function (context) {
        style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
      } : function (context) {
        style.call(this, createInjector(context));
      };
    }

    if (hook) {
      if (options.functional) {
        // register for functional component in vue file
        var originalRender = options.render;

        options.render = function renderWithStyleInjection(h, context) {
          hook.call(context);
          return originalRender(h, context);
        };
      } else {
        // inject component registration as beforeCreate hook
        var existing = options.beforeCreate;
        options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
      }
    }

    return script;
  }

  /* script */
  const __vue_script__ = script;
  /* template */
  var __vue_render__ = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',[_c('button',{staticClass:"btn btn-primary",on:{"click":_vm.toggle}},[_vm._v("\n    "+_vm._s(_vm.content)+"\n  ")])])};
  var __vue_staticRenderFns__ = [];

    /* style */
    const __vue_inject_styles__ = undefined;
    /* scoped */
    const __vue_scope_id__ = "data-v-4ec2404c";
    /* module identifier */
    const __vue_module_identifier__ = undefined;
    /* functional template */
    const __vue_is_functional_template__ = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__ = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
      __vue_inject_styles__,
      __vue_script__,
      __vue_scope_id__,
      __vue_is_functional_template__,
      __vue_module_identifier__,
      false,
      undefined,
      undefined,
      undefined
    );

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);

      if (enumerableOnly) {
        symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });
      }

      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
  }

  function _iterableToArrayLimit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;

    var _s, _e;

    try {
      for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

    return arr2;
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  var script$1 = {
    name: "EmotionLegend",
    props: {
      emotionColors: {
        type: Object,
        required: true
      }
    },
    computed: {
      legendItems: function legendItems() {
        var entries = Object.entries(this.emotionColors);
        return entries.map(function (_ref, index) {
          var _ref2 = _slicedToArray(_ref, 2),
              emotion = _ref2[0],
              color = _ref2[1];

          return {
            index: index,
            color: color,
            label: emotion
          };
        });
      },
      legendExist: function legendExist() {
        return !!this.legendItems.length;
      }
    }
  };

  /* script */
  const __vue_script__$1 = script$1;
  /* template */
  var __vue_render__$1 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"legend"},[_c('p',{staticClass:"legend--title"}),_vm._v(" "),_c('div',{staticClass:"legend--items"},_vm._l((_vm.legendItems),function(item){return _c('div',{key:item.index,staticClass:"legend--item"},[_c('div',{staticClass:"square",style:({ background: item.color })}),_vm._v(" "),_c('div',{staticClass:"legend--item--label"},[_vm._v(_vm._s(item.label))])])}),0)])};
  var __vue_staticRenderFns__$1 = [];

    /* style */
    const __vue_inject_styles__$1 = undefined;
    /* scoped */
    const __vue_scope_id__$1 = "data-v-541ae22a";
    /* module identifier */
    const __vue_module_identifier__$1 = undefined;
    /* functional template */
    const __vue_is_functional_template__$1 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__$1 = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
      __vue_inject_styles__$1,
      __vue_script__$1,
      __vue_scope_id__$1,
      __vue_is_functional_template__$1,
      __vue_module_identifier__$1,
      false,
      undefined,
      undefined,
      undefined
    );

  //
  var script$2 = {
    name: "TranscriptHeader",
    components: {
      EmotionSwitcher: __vue_component__,
      EmotionLegend: __vue_component__$1
    },
    props: {
      width: {
        type: Number,
        required: true
      },
      marginTop: {
        type: Number,
        required: true
      },
      emotionHidden: {
        type: Boolean,
        required: true
      },
      emotionColors: {
        type: Object,
        required: true
      }
    },
    data: function data() {
      return {
        offset: this.marginTop + 80
      };
    },
    computed: {
      legendStyles: function legendStyles() {
        return {
          opacity: this.emotionHidden ? 0 : 1
        };
      },
      affixStyles: function affixStyles() {
        return {
          display: "flex",
          flexDirection: "row",
          flexWrap: "nowrap",
          justifyContent: "space-between",
          alignItems: "center",
          alignContent: "stretch",
          zIndex: 1,
          width: "".concat(this.width, "px"),
          background: "#ffffff"
        };
      }
    }
  };

  /* script */
  const __vue_script__$2 = script$2;
  /* template */
  var __vue_render__$2 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('affix',{style:(_vm.affixStyles),attrs:{"offset":{ top: _vm.offset, bottom: _vm.offset },"relative-element-selector":"#transcript"}},[_c('emotion-switcher',{attrs:{"is-hide":_vm.emotionHidden},on:{"emotionToggle":function($event){return _vm.$emit('emotionToggle')}}}),_vm._v(" "),_c('emotion-legend',{style:(_vm.legendStyles),attrs:{"emotion-colors":_vm.emotionColors}})],1)};
  var __vue_staticRenderFns__$2 = [];

    /* style */
    const __vue_inject_styles__$2 = undefined;
    /* scoped */
    const __vue_scope_id__$2 = "data-v-2a26b7e6";
    /* module identifier */
    const __vue_module_identifier__$2 = undefined;
    /* functional template */
    const __vue_is_functional_template__$2 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__$2 = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__$2, staticRenderFns: __vue_staticRenderFns__$2 },
      __vue_inject_styles__$2,
      __vue_script__$2,
      __vue_scope_id__$2,
      __vue_is_functional_template__$2,
      __vue_module_identifier__$2,
      false,
      undefined,
      undefined,
      undefined
    );

  //
  var script$3 = {
    name: "Player",
    components: {
      VuePlyr: VuePlyr
    },
    props: {
      width: {
        required: true,
        type: Number
      },
      sourceFile: {
        required: true,
        type: String
      }
    },
    data: function data() {
      return {
        loading: true
      };
    },
    computed: {
      playerStyles: function playerStyles() {
        return {
          width: "".concat(this.width, "px")
        };
      }
    },
    mounted: function mounted() {
      var _this = this;

      this.$refs.audioElement.addEventListener("error", function () {
        console.log("ошибка загрузки файла");
      }, false);
      this.$refs.audioElement.addEventListener("loadeddata", function () {
        if (isNaN(_this.$refs.audioElement.duration)) {
          console.log("audio source is invalid");
          return;
        }

        _this.loading = false;
      }, false);
      this.$refs.audioElement.src = this.sourceFile;
    }
  };

  /* script */
  const __vue_script__$3 = script$3;
  /* template */
  var __vue_render__$3 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{directives:[{name:"show",rawName:"v-show",value:(!_vm.loading),expression:"!loading"}],staticClass:"player-wrapper",style:(_vm.playerStyles)},[_c('vue-plyr',[_c('audio',{ref:"audioElement"},[_c('source')])])],1)};
  var __vue_staticRenderFns__$3 = [];

    /* style */
    const __vue_inject_styles__$3 = undefined;
    /* scoped */
    const __vue_scope_id__$3 = "data-v-1986f832";
    /* module identifier */
    const __vue_module_identifier__$3 = undefined;
    /* functional template */
    const __vue_is_functional_template__$3 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__$3 = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__$3, staticRenderFns: __vue_staticRenderFns__$3 },
      __vue_inject_styles__$3,
      __vue_script__$3,
      __vue_scope_id__$3,
      __vue_is_functional_template__$3,
      __vue_module_identifier__$3,
      false,
      undefined,
      undefined,
      undefined
    );

  var emotionColors = {
    angry: '#fc2863',
    happy: '#ffd318',
    sad: '#272932',
    surprise: '#ff842c',
    neutral: '#e7ecef',
    default: 'transparent'
  };
  function getColor(emotion) {
    var emotionColors = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : emotionColors;
    return Object.prototype.hasOwnProperty.call(emotionColors, emotion) && emotionColors[emotion] || emotionColors.default;
  }

  //
  var script$4 = {
    name: "SpeechWord",
    props: {
      conf: {
        type: Number,
        required: true
      },
      start: {
        type: Number,
        required: true
      },
      end: {
        type: Number,
        required: true
      },
      emotion: {
        type: String,
        required: true
      },
      word: {
        type: String,
        required: true
      },
      emotionColors: {
        type: Object,
        required: true
      },
      emotionHidden: {
        type: Boolean,
        required: false,
        default: false
      }
    },
    computed: {
      getTimestamp: function getTimestamp() {
        var format = this.start > 3600 ? "HH:mm:ss:SS" : "mm:ss:SS";
        return moment.utc(this.start * 1000).format(format).toString();
      }
    },
    methods: {
      wordStyle: function wordStyle(emotion) {
        return !this.emotionHidden ? {
          borderBottom: "2px solid ".concat(getColor(emotion, this.emotionColors))
        } : {};
      }
    }
  };

  /* script */
  const __vue_script__$4 = script$4;
  /* template */
  var __vue_render__$4 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('span',{staticClass:"speech-word",style:(_vm.wordStyle(_vm.emotion)),attrs:{"data-conf":_vm.conf,"data-end":_vm.end,"data-start":_vm.start}},[_vm._v(_vm._s(_vm.word)+" ")])};
  var __vue_staticRenderFns__$4 = [];

    /* style */
    const __vue_inject_styles__$4 = undefined;
    /* scoped */
    const __vue_scope_id__$4 = "data-v-5aac6022";
    /* module identifier */
    const __vue_module_identifier__$4 = undefined;
    /* functional template */
    const __vue_is_functional_template__$4 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__$4 = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__$4, staticRenderFns: __vue_staticRenderFns__$4 },
      __vue_inject_styles__$4,
      __vue_script__$4,
      __vue_scope_id__$4,
      __vue_is_functional_template__$4,
      __vue_module_identifier__$4,
      false,
      undefined,
      undefined,
      undefined
    );

  //
  var script$5 = {
    name: "SpeechTimestamp",
    props: {
      speakerId: {
        type: [String, Number],
        required: true
      },
      timestamp: {
        type: Number,
        required: true
      }
    },
    methods: {
      getTimestamp: function getTimestamp(data) {
        var format = data > 3600 ? "HH:mm:ss" : "mm:ss";
        return moment.utc(data * 1000).format(format);
      },
      displaySpeakerName: function displaySpeakerName(speaker_id) {
        return +speaker_id ? "Speaker ".concat(speaker_id) : speaker_id;
      }
    }
  };

  /* script */
  const __vue_script__$5 = script$5;
  /* template */
  var __vue_render__$5 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('p',{staticClass:"speech-timestamp"},[_c('span',{staticClass:"speech-timestamp-content"},[_c('span',{staticClass:"speaker-photo"}),_vm._v(" "),_c('strong',{staticClass:"speaker-name"},[_vm._v("\n      "+_vm._s(_vm.displaySpeakerName(_vm.speakerId))+"\n    ")]),_vm._v("\n    "+_vm._s(_vm.getTimestamp(_vm.timestamp))+"\n  ")])])};
  var __vue_staticRenderFns__$5 = [];

    /* style */
    const __vue_inject_styles__$5 = undefined;
    /* scoped */
    const __vue_scope_id__$5 = "data-v-00ea0c5f";
    /* module identifier */
    const __vue_module_identifier__$5 = undefined;
    /* functional template */
    const __vue_is_functional_template__$5 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__$5 = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__$5, staticRenderFns: __vue_staticRenderFns__$5 },
      __vue_inject_styles__$5,
      __vue_script__$5,
      __vue_scope_id__$5,
      __vue_is_functional_template__$5,
      __vue_module_identifier__$5,
      false,
      undefined,
      undefined,
      undefined
    );

  var script$6 = {
    name: "Speech",
    components: {
      SpeechWord: __vue_component__$4,
      SpeechTimestamp: __vue_component__$5
    },
    props: {
      speech: {
        type: Object,
        required: true
      },
      speakerList: {
        type: Array,
        required: true
      },
      emotionColors: {
        type: Object,
        required: true
      },
      emotionHidden: {
        type: Boolean,
        required: false,
        default: false
      },
      isEditable: {
        type: Boolean,
        required: true
      }
    },
    data: function data() {
      return {
        keys: [],
        disabledKeys: [46]
      };
    },
    methods: {
      isInterviewer: function isInterviewer(speaker_id) {
        var speaker = this.speakerList.find(function (item) {
          return item.speaker_id === speaker_id;
        });
        return speaker && speaker.is_interviewer ? "interviewer-speaker" : "";
      },
      onInput: function onInput(e, collection, speech) {
        var _this = this;

        var _this$getCaretPositio = this.getCaretPosition(),
            _this$getCaretPositio2 = _slicedToArray(_this$getCaretPositio, 2),
            targetElement = _this$getCaretPositio2[0],
            savedPosition = _this$getCaretPositio2[1];

        this.$emit("handleSpeechEdit", {
          speech: speech,
          updatedSpeech: this.htmlCollectionToObject(collection)
        });
        var position = savedPosition === 1 ? savedPosition + 1 : savedPosition;
        setTimeout(function () {
          return _this.setCaretPosition(targetElement, position);
        }, 5);
      },
      handleKeydown: function handleKeydown(e) {
        if (this.keys.indexOf(e.keyCode) < 0) this.keys.push(e.keyCode);
        var filterKeys = this.keys.filter(function (key) {
          return key >= 48 && key <= 90;
        });
        if (filterKeys.length > 1 || this.disabledKeys.includes(e.keyCode)) e.preventDefault();
      },
      handleKeyup: function handleKeyup(e) {
        this.keys.splice(this.keys.indexOf(e.keyCode), 1);
      },
      prepareProps: function prepareProps(props) {
        var result = {};
        var validProps = {
          conf: parseInt,
          start: parseFloat,
          end: parseFloat,
          word: String
        };

        for (var prop in props) {
          if (Object.prototype.hasOwnProperty.call(props, prop) && Object.prototype.hasOwnProperty.call(validProps, prop)) {
            var validator = validProps[prop];
            result[prop] = validator(props[prop]);
          }
        }

        return result;
      },
      htmlCollectionToObject: function htmlCollectionToObject(collection) {
        var _this2 = this;

        var result = [];
        collection.forEach(function (item) {
          result.push(_this2.prepareProps(_objectSpread2(_objectSpread2({}, item.dataset), {}, {
            word: item.textContent.trim()
          })));
        });
        return result;
      },
      getCaretPosition: function getCaretPosition() {
        var caretOffset = 0;

        if (Object.hasOwnProperty.call(window, "getSelection")) {
          var range = window.getSelection().getRangeAt(0);
          var preCaretRange = range.cloneRange();
          preCaretRange.selectNodeContents(preCaretRange.startContainer);
          preCaretRange.setEnd(range.endContainer, range.endOffset);
          caretOffset = preCaretRange.toString().length;
          return [preCaretRange.startContainer, caretOffset];
        }

        return [null, 0];
      },
      setCaretPosition: function setCaretPosition(element, position) {
        var range = document.createRange();
        range.setStart(element, position);
        range.setEnd(element, position);
        var sel = window.getSelection();
        sel.removeAllRanges();
        sel.addRange(range);
      }
    }
  };

  /* script */
  const __vue_script__$6 = script$6;
  /* template */
  var __vue_render__$6 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"speech",class:_vm.isInterviewer(_vm.speech.speaker_id),on:{"click":function($event){return _vm.$emit('handleSpeechSelect', _vm.speech)}}},[_c('speech-timestamp',{attrs:{"speaker-id":_vm.speech.speaker_id,"timestamp":_vm.speech.timestamp}}),_vm._v(" "),_c('p',{staticClass:"speech-content",attrs:{"id":"editor","contenteditable":_vm.isEditable},on:{"keypress":function($event){if(!$event.type.indexOf('key')&&_vm._k($event.keyCode,"enter",13,$event.key,"Enter")){ return null; }$event.preventDefault();},"keydown":_vm.handleKeydown,"keyup":_vm.handleKeyup,"input":function($event){return _vm.onInput($event, $event.target.children, _vm.speech)}}},_vm._l((_vm.speech.text),function(word,key){return _c('speech-word',{key:key,attrs:{"conf":word.conf,"start":word.start,"end":word.end,"emotion":word.emotion,"word":word.word,"emotion-colors":_vm.emotionColors,"emotion-hidden":_vm.emotionHidden}})}),1)],1)};
  var __vue_staticRenderFns__$6 = [];

    /* style */
    const __vue_inject_styles__$6 = undefined;
    /* scoped */
    const __vue_scope_id__$6 = "data-v-17668fc2";
    /* module identifier */
    const __vue_module_identifier__$6 = undefined;
    /* functional template */
    const __vue_is_functional_template__$6 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__$6 = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__$6, staticRenderFns: __vue_staticRenderFns__$6 },
      __vue_inject_styles__$6,
      __vue_script__$6,
      __vue_scope_id__$6,
      __vue_is_functional_template__$6,
      __vue_module_identifier__$6,
      false,
      undefined,
      undefined,
      undefined
    );

  var script$7 = {
    name: "Transcript",
    components: {
      Speech: __vue_component__$6
    },
    props: {
      speeches: {
        type: Array,
        required: true
      },
      speakerList: {
        type: Array,
        required: true
      },
      emotionColors: {
        type: Object,
        required: true
      },
      emotionHidden: {
        type: Boolean,
        required: false,
        default: false
      },
      isEditable: {
        type: Boolean,
        required: true
      }
    },
    data: function data() {
      return {
        player: null,
        transcript: null,
        activeSpeech: null,
        isDirty: false,
        words: [],
        paras: []
      };
    },
    mounted: function mounted() {
      this.initPlayer();
      this.initTranscript();
      this.initSpeeches();
    },
    methods: {
      initPlayer: function initPlayer() {
        var _this = this;

        this.$parent.$children.forEach(function (child) {
          if (Object.hasOwnProperty.call(child.$refs, "audioElement")) {
            _this.player = child.$refs.audioElement;

            _this.player.addEventListener("timeupdate", _this.checkPlayHead, false);
          }
        });
      },
      initTranscript: function initTranscript() {
        if (this.$refs.transcript) {
          this.transcript = this.$refs.transcript;
          this.transcript.addEventListener("click", this.setPlayHead, false);
        }
      },
      initSpeeches: function initSpeeches() {
        this.words = _toConsumableArray(this.transcript.getElementsByClassName("speech-word"));
        this.paras = _toConsumableArray(this.transcript.getElementsByClassName("speech"));
      },
      clearActiveElements: function clearActiveElements() {
        var activeItems = this.transcript.querySelectorAll(".speech-word.active");

        for (var a = 0; a < activeItems.length; a++) {
          if (activeItems[a]) {
            // TODO: look into why we need this
            activeItems[a].classList.remove("active");
          }
        }
      },
      selectActiveItem: function selectActiveItem() {
        for (var i = 1; i < this.words.length; i++) {
          if (parseFloat(this.words[i].getAttribute("data-start")) > this.player.currentTime) {
            // TODO: look for a better way of doing this
            var strayActive = this.transcript.querySelectorAll(".speech-word.active")[0];

            if (strayActive) {
              strayActive.classList.remove("active");
            } // word time is in the future - set the previous word as active.


            this.words[i - 1].classList.add("active");
            break;
          }
        }
      },
      setPlayerTime: function setPlayerTime(time) {
        if (!isNaN(time)) {
          this.player.currentTime = time;
        }
      },
      setPlayHead: function setPlayHead(e) {
        this.clearActiveElements();
        var target = e.target ? e.target : e.srcElement;
        target.classList.add("active");
        var time = parseFloat(target.getAttribute("data-start"));
        this.setPlayerTime(time);
      },
      checkPlayHead: function checkPlayHead() {
        this.clearActiveElements();
        this.selectActiveItem();
      },
      updateSpeeches: function updateSpeeches(_ref) {
        var speech = _ref.speech,
            updatedSpeech = _ref.updatedSpeech;
        var speaker_id = speech.speaker_id,
            timestamp = speech.timestamp;
        var index = this.speeches.findIndex(function (item) {
          return item.speaker_id === speaker_id && item.timestamp === timestamp;
        });

        var newSpeech = _objectSpread2(_objectSpread2({}, speech), {}, {
          text: updatedSpeech
        });

        var newSpeeches = _objectSpread2(_objectSpread2({}, this.speeches), {}, _defineProperty({}, index, newSpeech));

        this.isDirty = true;
        this.$emit("updateSpeeches", Object.values(newSpeeches));
      },
      selectSpeech: function selectSpeech(speech) {
        this.activeSpeech = _objectSpread2({}, speech);
        this.$emit("changedActiveSpeech", this.isDirty);
        this.isDirty = false;
      }
    }
  };

  /* script */
  const __vue_script__$7 = script$7;
  /* template */
  var __vue_render__$7 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{ref:"transcript",staticClass:"textarea scroller has-fixed-size",attrs:{"id":"transcript"}},_vm._l((_vm.speeches),function(speech){return _c('speech',{key:speech.timestamp,attrs:{"speech":speech,"speaker-list":_vm.speakerList,"emotion-colors":_vm.emotionColors,"emotion-hidden":_vm.emotionHidden,"is-editable":_vm.isEditable},on:{"handleSpeechEdit":_vm.updateSpeeches,"handleSpeechSelect":_vm.selectSpeech}})}),1)};
  var __vue_staticRenderFns__$7 = [];

    /* style */
    const __vue_inject_styles__$7 = undefined;
    /* scoped */
    const __vue_scope_id__$7 = "data-v-e46ff346";
    /* module identifier */
    const __vue_module_identifier__$7 = undefined;
    /* functional template */
    const __vue_is_functional_template__$7 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__$7 = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__$7, staticRenderFns: __vue_staticRenderFns__$7 },
      __vue_inject_styles__$7,
      __vue_script__$7,
      __vue_scope_id__$7,
      __vue_is_functional_template__$7,
      __vue_module_identifier__$7,
      false,
      undefined,
      undefined,
      undefined
    );

  //
  var script$8 = {
    name: "VueTranscriptEditor",
    components: {
      TranscriptHeader: __vue_component__$2,
      Player: __vue_component__$3,
      Transcript: __vue_component__$7
    },
    props: {
      transcript: {
        type: Array,
        required: true
      },
      speakerList: {
        type: Array,
        required: true
      },
      emotionColors: {
        type: Object,
        required: false,
        default: function _default() {
          return emotionColors;
        }
      },
      sourceFile: {
        type: String,
        required: true
      },
      isEditable: {
        type: Boolean,
        default: true
      },
      isEmotionExist: {
        type: Boolean,
        default: false
      },
      headerMargin: {
        type: Number,
        default: 0
      }
    },
    data: function data() {
      return {
        isEmotionHide: true,
        componentWidth: 0
      };
    },
    mounted: function mounted() {
      window.addEventListener("resize", this.updateWidth);
      this.updateWidth();
    },
    methods: {
      updateWidth: function updateWidth() {
        var elementWidth = 0;

        if (this.$refs.editorWrapper) {
          var element = this.$refs.editorWrapper;
          elementWidth = element.clientWidth;
        }

        this.componentWidth = elementWidth;
      },
      updateTranscript: function updateTranscript(speeches) {
        this.$emit("updateTranscript", speeches);
      }
    }
  };

  /* script */
  const __vue_script__$8 = script$8;
  /* template */
  var __vue_render__$8 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{ref:"editorWrapper"},[(_vm.isEmotionExist)?_c('transcript-header',{attrs:{"width":_vm.componentWidth,"emotion-colors":_vm.emotionColors,"emotion-hidden":_vm.isEmotionHide,"margin-top":_vm.headerMargin},on:{"emotionToggle":function($event){_vm.isEmotionHide = !_vm.isEmotionHide;}}}):_vm._e(),_vm._v(" "),_c('transcript',{attrs:{"speeches":_vm.transcript,"speaker-list":_vm.speakerList,"emotion-colors":_vm.emotionColors,"emotion-hidden":!_vm.isEmotionExist || _vm.isEmotionHide,"is-editable":_vm.isEditable},on:{"updateSpeeches":_vm.updateTranscript,"changedActiveSpeech":function (isDirty) { return _vm.$emit('changedActiveSpeech', isDirty); }}}),_vm._v(" "),_c('player',{attrs:{"width":_vm.componentWidth,"source-file":_vm.sourceFile}})],1)};
  var __vue_staticRenderFns__$8 = [];

    /* style */
    const __vue_inject_styles__$8 = undefined;
    /* scoped */
    const __vue_scope_id__$8 = undefined;
    /* module identifier */
    const __vue_module_identifier__$8 = undefined;
    /* functional template */
    const __vue_is_functional_template__$8 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__$8 = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__$8, staticRenderFns: __vue_staticRenderFns__$8 },
      __vue_inject_styles__$8,
      __vue_script__$8,
      __vue_scope_id__$8,
      __vue_is_functional_template__$8,
      __vue_module_identifier__$8,
      false,
      undefined,
      undefined,
      undefined
    );

  var version = "0.4.0"; // Declare install function executed by Vue.use()

  function install(Vue) {
    if (install.installed) return;
    install.installed = true;
    Vue.component("VueTranscriptEditor", __vue_component__$8);
  }
  var VPlugin = {
    install: install,
    version: version,
    VueTranscriptEditor: __vue_component__$8
  }; // Auto-install when vue is found (eg. in browser via <script> tag)

  var GlobalVue = null;

  if (typeof window !== "undefined") {
    GlobalVue = window.Vue;
  } else if (typeof global !== "undefined") {
    GlobalVue = global.Vue;
  }

  if (GlobalVue) {
    GlobalVue.use(VPlugin);
  }
  /*************************************************/

  exports.VueTranscriptEditor = __vue_component__$8;
  exports.default = VPlugin;
  exports.install = install;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
